## Signals

Signals — A means for customization of object behaviour and a general purpose notification mechanism

## Functions

gboolean | (*GSignalAccumulator) ()
gboolean | (*GSignalEmissionHook) ()
guint | g_signal_new ()
guint | g_signal_newv ()
guint | g_signal_new_valist ()
void | g_signal_set_va_marshaller ()
void | g_signal_query ()
guint | g_signal_lookup ()
const gchar * | g_signal_name ()
guint * | g_signal_list_ids ()
void | g_signal_emit ()
void | g_signal_emit_by_name ()
void | g_signal_emitv ()
void | g_signal_emit_valist ()
#define | g_signal_connect()
#define | g_signal_connect_after()
#define | g_signal_connect_swapped()
gulong | g_signal_connect_object ()
gulong | g_signal_connect_data ()
gulong | g_signal_connect_closure ()
gulong | g_signal_connect_closure_by_id ()
void | g_signal_handler_block ()
void | g_signal_handler_unblock ()
void | g_signal_handler_disconnect ()
gulong | g_signal_handler_find ()
guint | g_signal_handlers_block_matched ()
guint | g_signal_handlers_unblock_matched ()
guint | g_signal_handlers_disconnect_matched ()
gboolean | g_signal_handler_is_connected ()
#define | g_signal_handlers_block_by_func()
#define | g_signal_handlers_unblock_by_func()
#define | g_signal_handlers_disconnect_by_func()
#define | g_signal_handlers_disconnect_by_data()
gboolean | g_signal_has_handler_pending ()
void | g_signal_stop_emission ()
void | g_signal_stop_emission_by_name ()
void | g_signal_override_class_closure ()
void | g_signal_chain_from_overridden ()
guint | g_signal_new_class_handler ()
void | g_signal_override_class_handler ()
void | g_signal_chain_from_overridden_handler ()
gulong | g_signal_add_emission_hook ()
void | g_signal_remove_emission_hook ()
gboolean | g_signal_parse_name ()
GSignalInvocationHint * | g_signal_get_invocation_hint ()
GClosure * | g_signal_type_cclosure_new ()
gboolean | g_signal_accumulator_first_wins ()
gboolean | g_signal_accumulator_true_handled ()

## Types and Values

struct | GSignalInvocationHint
typedef | GSignalCMarshaller
typedef | GSignalCVaMarshaller
enum | GSignalFlags
enum | GSignalMatchType
struct | GSignalQuery
#define | G_SIGNAL_TYPE_STATIC_SCOPE
#define | G_SIGNAL_MATCH_MASK
#define | G_SIGNAL_FLAGS_MASK
enum | GConnectFlags

## Includes

    #include <glib-object.h>

## Description

The basic concept of the signal system is that of the emission of a signal. Signals are introduced per-type and are identified through strings. Signals introduced for a parent type are available in derived types as well, so basically they are a per-type facility that is inherited.

A signal emission mainly involves invocation of a certain set of callbacks in precisely defined manner. There are two main categories of such callbacks, per-object ones and user provided ones. (Although signals can deal with any kind of instantiatable type, I'm referring to those types as "object types" in the following, simply because that is the context most users will encounter signals in.) The per-object callbacks are most often referred to as "object method handler" or "default (signal) handler", while user provided callbacks are usually just called "signal handler".

The object method handler is provided at signal creation time (this most frequently happens at the end of an object class' creation), while user provided handlers are frequently connected and disconnected to/from a certain signal on certain object instances.

A signal emission consists of five stages, unless prematurely stopped:

1. Invocation of the object method handler for `G_SIGNAL_RUN_FIRST` signals

2. Invocation of normal user-provided signal handlers (where the `after` flag is not set)

3. Invocation of the object method handler for `G_SIGNAL_RUN_LAST` signals

4. Invocation of user provided signal handlers (where the `after` flag is set)

5. Invocation of the object method handler for `G_SIGNAL_RUN_CLEANUP` signals

The user-provided signal handlers are called in the order they were connected in.

All handlers may prematurely stop a signal emission, and any number of handlers may be connected, disconnected, blocked or unblocked during a signal emission.

There are certain criteria for skipping user handlers in stages 2 and 4 of a signal emission.

First, user handlers may be blocked. Blocked handlers are omitted during callback invocation, to return from the blocked state, a handler has to get unblocked exactly the same amount of times it has been blocked before.

Second, upon emission of a `G_SIGNAL_DETAILED` signal, an additional `detail` argument passed in to `g_signal_emit()` has to match the detail argument of the signal handler currently subject to invocation. Specification of no detail argument for signal handlers (omission of the detail part of the signal specification upon connection) serves as a wildcard and matches any detail argument passed in to emission.

#### Memory management of signal handlers

If you are connecting handlers to signals and using a GObject instance as your signal handler user data, you should remember to pair calls to `g_signal_connect()` with calls to `g_signal_handler_disconnect()` or `g_signal_handlers_disconnect_by_func()`. While signal handlers are automatically disconnected when the object emitting the signal is finalised, they are not automatically disconnected when the signal handler user data is destroyed. If this user data is a GObject instance, using it from a signal handler after it has been finalised is an error.

There are two strategies for managing such user data. The first is to disconnect the signal handler (using `g_signal_handler_disconnect()` or `g_signal_handlers_disconnect_by_func()`) when the user data (object) is finalised; this has to be implemented manually. For non-threaded programs, `g_signal_connect_object()` can be used to implement this automatically. Currently, however, it is unsafe to use in threaded programs.

The second is to hold a strong reference on the user data until after the signal is disconnected for other reasons. This can be implemented automatically using `g_signal_connect_data()`.

The first approach is recommended, as the second approach can result in effective memory leaks of the user data if the signal handler is never disconnected for some reason.

## Functions

### GSignalAccumulator ()

    gboolean
    (*GSignalAccumulator) (GSignalInvocationHint *ihint,
                           GValue *return_accu,
                           const GValue *handler_return,
                           gpointer data);

The signal accumulator is a special callback function that can be used to collect return values of the various callbacks that are called during a signal emission. The signal accumulator is specified at signal creation time, if it is left `NULL`, no accumulation of callback return values is performed. The return value of signal emissions is then the value returned by the last callback.

#### Parameters

ihint | Signal invocation hint, see GSignalInvocationHint. |
return_accu | Accumulator to collect callback return values in, this is the return value of the current signal emission. |
handler_return | A GValue holding the return value of the signal handler. |
data | Callback data that was specified when creating the signal. |

#### Returns

The accumulator function returns whether the signal emission should be aborted. Returning `FALSE` means to abort the current emission and `TRUE` is returned for continuation.

### GSignalEmissionHook ()

    gboolean
    (*GSignalEmissionHook) (GSignalInvocationHint *ihint,
                            guint n_param_values,
                            const GValue *param_values,
                            gpointer data);

A simple function pointer to get invoked when the signal is emitted. This allows you to tie a hook to the signal type, so that it will trap all emissions of that signal, from any object.

You may not attach these to signals created with the G_SIGNAL_NO_HOOKS flag.

#### Parameters

ihint | Signal invocation hint, see GSignalInvocationHint. |
n_param_values | the number of parameters to the function, including the instance on which the signal was emitted. |
param_values | the instance on which the signal was emitted, followed by the parameters of the emission. | [array length=n_param_values]
data | user data associated with the hook. |

#### Returns

whether it wants to stay connected. If it returns `FALSE`, the signal hook is disconnected (and destroyed).

### g_signal_new ()

    guint
    g_signal_new (const gchar *signal_name,
                  GType itype,
                  GSignalFlags signal_flags,
                  guint class_offset,
                  GSignalAccumulator accumulator,
                  gpointer accu_data,
                  GSignalCMarshaller c_marshaller,
                  GType return_type,
                  guint n_params,
                  ...);

Creates a new signal. (This is usually done in the class initializer.)

A signal name consists of segments consisting of ASCII letters and digits, separated by either the '-' or '_' character. The first character of a signal name must be a letter. Names which violate these rules lead to undefined behaviour of the GSignal system.

When registering a signal and looking up a signal, either separator can be used, but they cannot be mixed.

If 0 is used for `class_offset` subclasses cannot override the class handler in their class_init method by doing super_class->signal_handler = my_signal_handler. Instead they will have to use `g_signal_override_class_handler()`.

If c_marshaller is `NULL`, `g_cclosure_marshal_generic()` will be used as the marshaller for this signal.

#### Parameters

signal_name | the name for the signal |
itype | the type this signal pertains to. It will also pertain to types which are derived from this type. |
signal_flags | a combination of GSignalFlags specifying detail of when the default handler is to be invoked. You should at least specify `G_SIGNAL_RUN_FIRST` or `G_SIGNAL_RUN_LAST`. |
class_offset | The offset of the function pointer in the class structure for this type. Used to invoke a class method generically. Pass 0 to not associate a class method slot with this signal. |
accumulator | the accumulator for this signal; may be `NULL`. |
accu_data | user data for the `accumulator` . |
c_marshaller | the function to translate arrays of parameter values to signal emissions into C language callback invocations or `NULL`. | [nullable]
return_type | the type of return value, or G_TYPE_NONE for a signal without a return value. |
n_params | the number of parameter types to follow. |
... | a list of types, one for each parameter. |

#### Returns

the signal id

### g_signal_newv ()

    guint
    g_signal_newv (const gchar *signal_name,
                   GType itype,
                   GSignalFlags signal_flags,
                   GClosure *class_closure,
                   GSignalAccumulator accumulator,
                   gpointer accu_data,
                   GSignalCMarshaller c_marshaller,
                   GType return_type,
                   guint n_params,
                   GType *param_types);

Creates a new signal. (This is usually done in the class initializer.)

See `g_signal_new()` for details on allowed signal names.

If c_marshaller is `NULL`, `g_cclosure_marshal_generic()` will be used as the marshaller for this signal.

#### Parameters

signal_name | the name for the signal |
itype | the type this signal pertains to. It will also pertain to types which are derived from this type |
signal_flags | a combination of GSignalFlags specifying detail of when the default handler is to be invoked. You should at least specify `G_SIGNAL_RUN_FIRST` or `G_SIGNAL_RUN_LAST` |
class_closure | The closure to invoke on signal emission; may be `NULL`. | [nullable]
accumulator | the accumulator for this signal; may be `NULL`. | [nullable]
accu_data | user data for the `accumulator` |
c_marshaller | the function to translate arrays of parameter values to signal emissions into C language callback invocations or `NULL`. | [nullable]
return_type | the type of return value, or G_TYPE_NONE for a signal without a return value |
n_params | the length of `param_types` |
param_types | an array of types, one for each parameter. | [array length=n_params]

#### Returns

the signal id

### g_signal_new_valist ()

    guint
    g_signal_new_valist (const gchar *signal_name,
                         GType itype,
                         GSignalFlags signal_flags,
                         GClosure *class_closure,
                         GSignalAccumulator accumulator,
                         gpointer accu_data,
                         GSignalCMarshaller c_marshaller,
                         GType return_type,
                         guint n_params,
                         va_list args);

Creates a new signal. (This is usually done in the class initializer.)

See `g_signal_new()` for details on allowed signal names.

If c_marshaller is `NULL`, `g_cclosure_marshal_generic()` will be used as the marshaller for this signal.

#### Parameters

signal_name | the name for the signal |
itype | the type this signal pertains to. It will also pertain to types which are derived from this type. |
signal_flags | a combination of GSignalFlags specifying detail of when the default handler is to be invoked. You should at least specify `G_SIGNAL_RUN_FIRST` or `G_SIGNAL_RUN_LAST`. |
class_closure | The closure to invoke on signal emission; may be `NULL`. |
accumulator | the accumulator for this signal; may be `NULL`. |
accu_data | user data for the `accumulator` . |
c_marshaller | the function to translate arrays of parameter values to signal emissions into C language callback invocations or `NULL`. | [nullable]
return_type | the type of return value, or G_TYPE_NONE for a signal without a return value. |
n_params | the number of parameter types in `args` . |
args | va_list of GType, one for each parameter. |

#### Returns

the signal id

### g_signal_set_va_marshaller ()

    void
    g_signal_set_va_marshaller (guint signal_id,
                                GType instance_type,
                                GSignalCVaMarshaller va_marshaller);

Change the GSignalCVaMarshaller used for a given signal. This is a specialised form of the marshaller that can often be used for the common case of a single connected signal handler and avoids the overhead of GValue. Its use is optional.

#### Parameters

signal_id | the signal id |
instance_type | the instance type on which to set the marshaller. |
va_marshaller | the marshaller to set. |

Since: 2.32

### g_signal_query ()

    void
    g_signal_query (guint signal_id,
                    GSignalQuery *query);

Queries the signal system for in-depth information about a specific signal. This function will fill in a user-provided structure to hold signal-specific information. If an invalid signal id is passed in, the `signal_id` member of the GSignalQuery is 0. All members filled into the GSignalQuery structure should be considered constant and have to be left untouched.

#### Parameters

signal_id | The signal id of the signal to query information for. |
query | A user provided structure that is filled in with constant values upon success. | [out caller-allocates]

### g_signal_lookup ()

    guint
    g_signal_lookup (const gchar *name,
                     GType itype);

Given the name of the signal and the type of object it connects to, gets the signal's identifying integer. Emitting the signal by number is somewhat faster than using the name each time.

Also tries the ancestors of the given type.

See `g_signal_new()` for details on allowed signal names.

#### Parameters

name | the signal's name. |
itype | the type that the signal operates on. |

#### Returns

the signal's identifying number, or 0 if no signal was found.

### g_signal_name ()

    const gchar *
    g_signal_name (guint signal_id);

Given the signal's identifier, finds its name.

Two different signals may have the same name, if they have differing types.

#### Parameters

signal_id | the signal's identifying number. |

#### Returns

the signal name, or `NULL` if the signal number was invalid.

### g_signal_list_ids ()

    guint *
    g_signal_list_ids (GType itype,
                       guint *n_ids);

Lists the signals by id that a certain instance or interface type created. Further information about the signals can be acquired through `g_signal_query()`.

#### Parameters

itype | Instance or interface type. |
n_ids | Location to store the number of signal ids for `itype` . |

#### Returns

Newly allocated array of signal IDs.

[array length=n_ids][transfer full]

### g_signal_emit ()

    void
    g_signal_emit (gpointer instance,
                   guint signal_id,
                   GQuark detail,
                   ...);

Emits a signal.

Note that `g_signal_emit()` resets the return value to the default if no handlers are connected, in contrast to `g_signal_emitv()`.

#### Parameters

instance | the instance the signal is being emitted on. | [type GObject.Object]
signal_id | the signal id |
detail | the detail |
... | parameters to be passed to the signal, followed by a location for the return value. If the return type of the signal is G_TYPE_NONE, the return value location can be omitted. |

### g_signal_emit_by_name ()

    void
    g_signal_emit_by_name (gpointer instance,
                           const gchar *detailed_signal,
                           ...);

Emits a signal.

Note that `g_signal_emit_by_name()` resets the return value to the default if no handlers are connected, in contrast to `g_signal_emitv()`.

#### Parameters

instance | the instance the signal is being emitted on. | [type GObject.Object]
detailed_signal | a string of the form "signal-name::detail". |
... | parameters to be passed to the signal, followed by a location for the return value. If the return type of the signal is G_TYPE_NONE, the return value location can be omitted. |

### g_signal_emitv ()

    void
    g_signal_emitv (const GValue *instance_and_params,
                    guint signal_id,
                    GQuark detail,
                    GValue *return_value);

Emits a signal.

Note that `g_signal_emitv()` doesn't change `return_value` if no handlers are connected, in contrast to `g_signal_emit()` and `g_signal_emit_valist()`.

#### Parameters

instance_and_params | argument list for the signal emission. The first element in the array is a GValue for the instance the signal is being emitted on. The rest are any arguments to be passed to the signal. | [array]
signal_id | the signal id |
detail | the detail |
return_value | Location to store the return value of the signal emission. This must be provided if the specified signal returns a value, but may be ignored otherwise. | [inout][optional]

### g_signal_emit_valist ()

    void
    g_signal_emit_valist (gpointer instance,
                          guint signal_id,
                          GQuark detail,
                          va_list var_args);

Emits a signal.

Note that `g_signal_emit_valist()` resets the return value to the default if no handlers are connected, in contrast to `g_signal_emitv()`.

[skip]

#### Parameters

instance | the instance the signal is being emitted on. | [type GObject.TypeInstance]
signal_id | the signal id |
detail | the detail |
var_args | a list of parameters to be passed to the signal, followed by a location for the return value. If the return type of the signal is G_TYPE_NONE, the return value location can be omitted. |

### g_signal_connect()

    #define             g_signal_connect(instance, detailed_signal, c_handler, data)

Connects a GCallback function to a signal for a particular object.

The handler will be called before the default handler of the signal.

See memory management of signal handlers for details on how to handle the return value and memory management of `data` .

#### Parameters

instance | the instance to connect to. |
detailed_signal | a string of the form "signal-name::detail". |
c_handler | the GCallback to connect. |
data | data to pass to `c_handler` calls. |

#### Returns

the handler ID, of type gulong (always greater than 0 for successful connections)

### g_signal_connect_after()

    #define             g_signal_connect_after(instance, detailed_signal, c_handler, data)

Connects a GCallback function to a signal for a particular object.

The handler will be called after the default handler of the signal.

#### Parameters

instance | the instance to connect to. |
detailed_signal | a string of the form "signal-name::detail". |
c_handler | the GCallback to connect. |
data | data to pass to `c_handler` calls. |

#### Returns

the handler ID, of type gulong (always greater than 0 for successful connections)

### g_signal_connect_swapped()

    #define             g_signal_connect_swapped(instance, detailed_signal, c_handler, data)

Connects a GCallback function to a signal for a particular object.

The instance on which the signal is emitted and `data` will be swapped when calling the handler. This is useful when calling pre-existing functions to operate purely on the `data` , rather than the `instance` : swapping the parameters avoids the need to write a wrapper function.

For example, this allows the shorter code:

    1
    2

    g_signal_connect_swapped (button, "clicked",
                              (GCallback) gtk_widget_hide, other_widget);

Rather than the cumbersome:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10

    static void
    button_clicked_cb (GtkButton *button, GtkWidget *other_widget)
    {
        gtk_widget_hide (other_widget);
    }

    ...

    g_signal_connect (button, "clicked",
                      (GCallback) button_clicked_cb, other_widget);

#### Parameters

instance | the instance to connect to. |
detailed_signal | a string of the form "signal-name::detail". |
c_handler | the GCallback to connect. |
data | data to pass to `c_handler` calls. |

#### Returns

the handler ID, of type gulong (always greater than 0 for successful connections)

### g_signal_connect_object ()

    gulong
    g_signal_connect_object (gpointer instance,
                             const gchar *detailed_signal,
                             GCallback c_handler,
                             gpointer gobject,
                             GConnectFlags connect_flags);

This is similar to `g_signal_connect_data()`, but uses a closure which ensures that the `gobject` stays alive during the call to `c_handler` by temporarily adding a reference count to `gobject` .

When the `gobject` is destroyed the signal handler will be automatically disconnected. Note that this is not currently threadsafe (ie: emitting a signal while `gobject` is being destroyed in another thread is not safe).

[skip]

#### Parameters

instance | the instance to connect to. | [type GObject.TypeInstance]
detailed_signal | a string of the form "signal-name::detail". |
c_handler | the GCallback to connect. |
gobject | the object to pass as data to `c_handler` . | [type GObject.Object][nullable]
connect_flags | a combination of GConnectFlags. |

#### Returns

the handler id.

### g_signal_connect_data ()

    gulong
    g_signal_connect_data (gpointer instance,
                           const gchar *detailed_signal,
                           GCallback c_handler,
                           gpointer data,
                           GClosureNotify destroy_data,
                           GConnectFlags connect_flags);

Connects a GCallback function to a signal for a particular object. Similar to `g_signal_connect()`, but allows to provide a GClosureNotify for the data which will be called when the signal handler is disconnected and no longer used. Specify `connect_flags` if you need `..._after()` or `..._swapped()` variants of this function.

#### Parameters

instance | the instance to connect to. | [type GObject.Object]
detailed_signal | a string of the form "signal-name::detail". |
c_handler | the GCallback to connect. |
data | data to pass to `c_handler` calls. |
destroy_data | a GClosureNotify for `data` . |
connect_flags | a combination of GConnectFlags. |

#### Returns

the handler ID (always greater than 0 for successful connections)

### g_signal_connect_closure ()

    gulong
    g_signal_connect_closure (gpointer instance,
                              const gchar *detailed_signal,
                              GClosure *closure,
                              gboolean after);

Connects a closure to a signal for a particular object.

#### Parameters

instance | the instance to connect to. | [type GObject.Object]
detailed_signal | a string of the form "signal-name::detail". |
closure | the closure to connect. |
after | whether the handler should be called before or after the default handler of the signal. |

#### Returns

the handler ID (always greater than 0 for successful connections)

### g_signal_connect_closure_by_id ()

    gulong
    g_signal_connect_closure_by_id (gpointer instance,
                                    guint signal_id,
                                    GQuark detail,
                                    GClosure *closure,
                                    gboolean after);

Connects a closure to a signal for a particular object.

#### Parameters

instance | the instance to connect to. | [type GObject.Object]
signal_id | the id of the signal. |
detail | the detail. |
closure | the closure to connect. |
after | whether the handler should be called before or after the default handler of the signal. |

#### Returns

the handler ID (always greater than 0 for successful connections)

### g_signal_handler_block ()

    void
    g_signal_handler_block (gpointer instance,
                            gulong handler_id);

Blocks a handler of an instance so it will not be called during any signal emissions unless it is unblocked again. Thus "blocking" a signal handler means to temporarily deactive it, a signal handler has to be unblocked exactly the same amount of times it has been blocked before to become active again.

The `handler_id` has to be a valid signal handler id, connected to a signal of `instance` .

#### Parameters

instance | The instance to block the signal handler of. | [type GObject.Object]
handler_id | Handler id of the handler to be blocked. |

### g_signal_handler_unblock ()

    void
    g_signal_handler_unblock (gpointer instance,
                              gulong handler_id);

Undoes the effect of a previous `g_signal_handler_block()` call. A blocked handler is skipped during signal emissions and will not be invoked, unblocking it (for exactly the amount of times it has been blocked before) reverts its "blocked" state, so the handler will be recognized by the signal system and is called upon future or currently ongoing signal emissions (since the order in which handlers are called during signal emissions is deterministic, whether the unblocked handler in question is called as part of a currently ongoing emission depends on how far that emission has proceeded yet).

The `handler_id` has to be a valid id of a signal handler that is connected to a signal of `instance` and is currently blocked.

#### Parameters

instance | The instance to unblock the signal handler of. | [type GObject.Object]
handler_id | Handler id of the handler to be unblocked. |

### g_signal_handler_disconnect ()

    void
    g_signal_handler_disconnect (gpointer instance,
                                 gulong handler_id);

Disconnects a handler from an instance so it will not be called during any future or currently ongoing emissions of the signal it has been connected to. The `handler_id` becomes invalid and may be reused.

The `handler_id` has to be a valid signal handler id, connected to a signal of `instance` .

#### Parameters

instance | The instance to remove the signal handler from. | [type GObject.Object]
handler_id | Handler id of the handler to be disconnected. |

### g_signal_handler_find ()

    gulong
    g_signal_handler_find (gpointer instance,
                           GSignalMatchType mask,
                           guint signal_id,
                           GQuark detail,
                           GClosure *closure,
                           gpointer func,
                           gpointer data);

Finds the first signal handler that matches certain selection criteria. The criteria mask is passed as an OR-ed combination of GSignalMatchType flags, and the criteria values are passed as arguments. The match `mask` has to be non-0 for successful matches. If no handler was found, 0 is returned.

#### Parameters

instance | The instance owning the signal handler to be found. | [type GObject.Object]
mask | Mask indicating which of `signal_id` , `detail` , `closure` , `func` and/or `data` the handler has to match. |
signal_id | Signal the handler has to be connected to. |
detail | Signal detail the handler has to be connected to. |
closure | The closure the handler will invoke. | [nullable]
func | The C closure callback of the handler (useless for non-C closures). |
data | The closure data of the handler's closure. |

#### Returns

A valid non-0 signal handler id for a successful match.

### g_signal_handlers_block_matched ()

    guint
    g_signal_handlers_block_matched (gpointer instance,
                                     GSignalMatchType mask,
                                     guint signal_id,
                                     GQuark detail,
                                     GClosure *closure,
                                     gpointer func,
                                     gpointer data);

Blocks all handlers on an instance that match a certain selection criteria. The criteria mask is passed as an OR-ed combination of GSignalMatchType flags, and the criteria values are passed as arguments. Passing at least one of the `G_SIGNAL_MATCH_CLOSURE`, `G_SIGNAL_MATCH_FUNC` or `G_SIGNAL_MATCH_DATA` match flags is required for successful matches. If no handlers were found, 0 is returned, the number of blocked handlers otherwise.

#### Parameters

instance | The instance to block handlers from. | [type GObject.Object]
mask | Mask indicating which of `signal_id` , `detail` , `closure` , `func` and/or `data` the handlers have to match. |
signal_id | Signal the handlers have to be connected to. |
detail | Signal detail the handlers have to be connected to. |
closure | The closure the handlers will invoke. | [nullable]
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handlers_unblock_matched ()

    guint
    g_signal_handlers_unblock_matched (gpointer instance,
                                       GSignalMatchType mask,
                                       guint signal_id,
                                       GQuark detail,
                                       GClosure *closure,
                                       gpointer func,
                                       gpointer data);

Unblocks all handlers on an instance that match a certain selection criteria. The criteria mask is passed as an OR-ed combination of GSignalMatchType flags, and the criteria values are passed as arguments. Passing at least one of the `G_SIGNAL_MATCH_CLOSURE`, `G_SIGNAL_MATCH_FUNC` or `G_SIGNAL_MATCH_DATA` match flags is required for successful matches. If no handlers were found, 0 is returned, the number of unblocked handlers otherwise. The match criteria should not apply to any handlers that are not currently blocked.

#### Parameters

instance | The instance to unblock handlers from. | [type GObject.Object]
mask | Mask indicating which of `signal_id` , `detail` , `closure` , `func` and/or `data` the handlers have to match. |
signal_id | Signal the handlers have to be connected to. |
detail | Signal detail the handlers have to be connected to. |
closure | The closure the handlers will invoke. | [nullable]
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handlers_disconnect_matched ()

    guint
    g_signal_handlers_disconnect_matched (gpointer instance,
                                          GSignalMatchType mask,
                                          guint signal_id,
                                          GQuark detail,
                                          GClosure *closure,
                                          gpointer func,
                                          gpointer data);

Disconnects all handlers on an instance that match a certain selection criteria. The criteria mask is passed as an OR-ed combination of GSignalMatchType flags, and the criteria values are passed as arguments. Passing at least one of the `G_SIGNAL_MATCH_CLOSURE`, `G_SIGNAL_MATCH_FUNC` or `G_SIGNAL_MATCH_DATA` match flags is required for successful matches. If no handlers were found, 0 is returned, the number of disconnected handlers otherwise.

#### Parameters

instance | The instance to remove handlers from. | [type GObject.Object]
mask | Mask indicating which of `signal_id` , `detail` , `closure` , `func` and/or `data` the handlers have to match. |
signal_id | Signal the handlers have to be connected to. |
detail | Signal detail the handlers have to be connected to. |
closure | The closure the handlers will invoke. | [nullable]
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handler_is_connected ()

    gboolean
    g_signal_handler_is_connected (gpointer instance,
                                   gulong handler_id);

Returns whether `handler_id` is the ID of a handler connected to `instance` .

#### Parameters

instance | The instance where a signal handler is sought. | [type GObject.Object]
handler_id | the handler ID. |

#### Returns

whether `handler_id` identifies a handler connected to `instance` .

### g_signal_handlers_block_by_func()

    #define             g_signal_handlers_block_by_func(instance, func, data)

Blocks all handlers on an instance that match `func` and `data` .

#### Parameters

instance | The instance to block handlers from. |
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handlers_unblock_by_func()

    #define             g_signal_handlers_unblock_by_func(instance, func, data)

Unblocks all handlers on an instance that match `func` and `data` .

#### Parameters

instance | The instance to unblock handlers from. |
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handlers_disconnect_by_func()

    #define             g_signal_handlers_disconnect_by_func(instance, func, data)

Disconnects all handlers on an instance that match `func` and `data` .

#### Parameters

instance | The instance to remove handlers from. |
func | The C closure callback of the handlers (useless for non-C closures). |
data | The closure data of the handlers' closures. |

#### Returns

The number of handlers that matched.

### g_signal_handlers_disconnect_by_data()

    #define             g_signal_handlers_disconnect_by_data(instance, data)

Disconnects all handlers on an instance that match `data` .

#### Parameters

instance | The instance to remove handlers from |
data | the closure data of the handlers' closures |

#### Returns

The number of handlers that matched.

Since: 2.32

### g_signal_has_handler_pending ()

    gboolean
    g_signal_has_handler_pending (gpointer instance,
                                  guint signal_id,
                                  GQuark detail,
                                  gboolean may_be_blocked);

Returns whether there are any handlers connected to `instance` for the given signal id and detail.

If `detail` is 0 then it will only match handlers that were connected without detail. If `detail` is non-zero then it will match handlers connected both without detail and with the given detail. This is consistent with how a signal emitted with `detail` would be delivered to those handlers.

Since 2.46 this also checks for a non-default class closure being installed, as this is basically always what you want.

One example of when you might use this is when the arguments to the signal are difficult to compute. A class implementor may opt to not emit the signal if no one is attached anyway, thus saving the cost of building the arguments.

#### Parameters

instance | the object whose signal handlers are sought. | [type GObject.Object]
signal_id | the signal id. |
detail | the detail. |
may_be_blocked | whether blocked handlers should count as match. |

#### Returns

`TRUE` if a handler is connected to the signal, `FALSE` otherwise.

### g_signal_stop_emission ()

    void
    g_signal_stop_emission (gpointer instance,
                            guint signal_id,
                            GQuark detail);

Stops a signal's current emission.

This will prevent the default method from running, if the signal was `G_SIGNAL_RUN_LAST` and you connected normally (i.e. without the "after" flag).

Prints a warning if used on a signal which isn't being emitted.

#### Parameters

instance | the object whose signal handlers you wish to stop. | [type GObject.Object]
signal_id | the signal identifier, as returned by `g_signal_lookup()`. |
detail | the detail which the signal was emitted with. |

### g_signal_stop_emission_by_name ()

    void
    g_signal_stop_emission_by_name (gpointer instance,
                                    const gchar *detailed_signal);

Stops a signal's current emission.

This is just like `g_signal_stop_emission()` except it will look up the signal id for you.

#### Parameters

instance | the object whose signal handlers you wish to stop. | [type GObject.Object]
detailed_signal | a string of the form "signal-name::detail". |

### g_signal_override_class_closure ()

    void
    g_signal_override_class_closure (guint signal_id,
                                     GType instance_type,
                                     GClosure *class_closure);

Overrides the class closure (i.e. the default handler) for the given signal for emissions on instances of `instance_type` . `instance_type` must be derived from the type to which the signal belongs.

See `g_signal_chain_from_overridden()` and `g_signal_chain_from_overridden_handler()` for how to chain up to the parent class closure from inside the overridden one.

#### Parameters

signal_id | the signal id |
instance_type | the instance type on which to override the class closure for the signal. |
class_closure | the closure. |

### g_signal_chain_from_overridden ()

    void
    g_signal_chain_from_overridden (const GValue *instance_and_params,
                                    GValue *return_value);

Calls the original class closure of a signal. This function should only be called from an overridden class closure; see `g_signal_override_class_closure()` and `g_signal_override_class_handler()`.

#### Parameters

instance_and_params | (array) the argument list of the signal emission. The first element in the array is a GValue for the instance the signal is being emitted on. The rest are any arguments to be passed to the signal. |
return_value | Location for the return value. |

### g_signal_new_class_handler ()

    guint
    g_signal_new_class_handler (const gchar *signal_name,
                                GType itype,
                                GSignalFlags signal_flags,
                                GCallback class_handler,
                                GSignalAccumulator accumulator,
                                gpointer accu_data,
                                GSignalCMarshaller c_marshaller,
                                GType return_type,
                                guint n_params,
                                ...);

Creates a new signal. (This is usually done in the class initializer.)

This is a variant of `g_signal_new()` that takes a C callback instead off a class offset for the signal's class handler. This function doesn't need a function pointer exposed in the class structure of an object definition, instead the function pointer is passed directly and can be overriden by derived classes with `g_signal_override_class_closure()` or `g_signal_override_class_handler()`and chained to with `g_signal_chain_from_overridden()` or `g_signal_chain_from_overridden_handler()`.

See `g_signal_new()` for information about signal names.

If c_marshaller is `NULL`, `g_cclosure_marshal_generic()` will be used as the marshaller for this signal.

#### Parameters

signal_name | the name for the signal |
itype | the type this signal pertains to. It will also pertain to types which are derived from this type. |
signal_flags | a combination of GSignalFlags specifying detail of when the default handler is to be invoked. You should at least specify `G_SIGNAL_RUN_FIRST` or `G_SIGNAL_RUN_LAST`. |
class_handler | a GCallback which acts as class implementation of this signal. Used to invoke a class method generically. Pass `NULL` to not associate a class method with this signal. |
accumulator | the accumulator for this signal; may be `NULL`. |
accu_data | user data for the `accumulator` . |
c_marshaller | the function to translate arrays of parameter values to signal emissions into C language callback invocations or `NULL`. | [nullable]
return_type | the type of return value, or G_TYPE_NONE for a signal without a return value. |
n_params | the number of parameter types to follow. |
... | a list of types, one for each parameter. |

#### Returns

the signal id

Since: 2.18

### g_signal_override_class_handler ()

    void
    g_signal_override_class_handler (const gchar *signal_name,
                                     GType instance_type,
                                     GCallback class_handler);

Overrides the class closure (i.e. the default handler) for the given signal for emissions on instances of `instance_type` with callback `class_handler` . `instance_type` must be derived from the type to which the signal belongs.

See `g_signal_chain_from_overridden()` and `g_signal_chain_from_overridden_handler()` for how to chain up to the parent class closure from inside the overridden one.

#### Parameters

signal_name | the name for the signal |
instance_type | the instance type on which to override the class handler for the signal. |
class_handler | the handler. |

Since: 2.18

### g_signal_chain_from_overridden_handler ()

    void
    g_signal_chain_from_overridden_handler
                                   (gpointer instance,
                                    ...);

Calls the original class closure of a signal. This function should only be called from an overridden class closure; see `g_signal_override_class_closure()` and `g_signal_override_class_handler()`.

[skip]

#### Parameters

instance | the instance the signal is being emitted on. | [type GObject.TypeInstance]
... | parameters to be passed to the parent class closure, followed by a location for the return value. If the return type of the signal is G_TYPE_NONE, the return value location can be omitted. |

Since: 2.18

### g_signal_add_emission_hook ()

    gulong
    g_signal_add_emission_hook (guint signal_id,
                                GQuark detail,
                                GSignalEmissionHook hook_func,
                                gpointer hook_data,
                                GDestroyNotify data_destroy);

Adds an emission hook for a signal, which will get called for any emission of that signal, independent of the instance. This is possible only for signals which don't have G_SIGNAL_NO_HOOKS flag set.

#### Parameters

signal_id | the signal identifier, as returned by `g_signal_lookup()`. |
detail | the detail on which to call the hook. |
hook_func | a GSignalEmissionHook function. |
hook_data | user data for `hook_func` . |
data_destroy | a GDestroyNotify for `hook_data` . |

#### Returns

the hook id, for later use with `g_signal_remove_emission_hook()`.

### g_signal_remove_emission_hook ()

    void
    g_signal_remove_emission_hook (guint signal_id,
                                   gulong hook_id);

Deletes an emission hook.

#### Parameters

signal_id | the id of the signal |
hook_id | the id of the emission hook, as returned by `g_signal_add_emission_hook()` |

### g_signal_parse_name ()

    gboolean
    g_signal_parse_name (const gchar *detailed_signal,
                         GType itype,
                         guint *signal_id_p,
                         GQuark *detail_p,
                         gboolean force_detail_quark);

Internal function to parse a signal name into its `signal_id` and `detail` quark.

#### Parameters

detailed_signal | a string of the form "signal-name::detail". |
itype | The interface/instance type that introduced "signal-name". |
signal_id_p | Location to store the signal id. | [out]
detail_p | Location to store the detail quark. | [out]
force_detail_quark | `TRUE` forces creation of a GQuark for the detail. |

#### Returns

Whether the signal name could successfully be parsed and `signal_id_p` and `detail_p` contain valid return values.

### g_signal_get_invocation_hint ()

    GSignalInvocationHint *
    g_signal_get_invocation_hint (gpointer instance);

Returns the invocation hint of the innermost signal emission of instance.

#### Parameters

instance | the instance to query. | [type GObject.Object]

#### Returns

the invocation hint of the innermost signal emission.

[transfer none]

### g_signal_type_cclosure_new ()

    GClosure *
    g_signal_type_cclosure_new (GType itype,
                                guint struct_offset);

Creates a new closure which invokes the function found at the offset `struct_offset` in the class structure of the interface or classed type identified by `itype` .

#### Parameters

itype | the GType identifier of an interface or classed type |
struct_offset | the offset of the member function of `itype` 's class structure which is to be invoked by the new closure |

#### Returns

a new GCClosure

### g_signal_accumulator_first_wins ()

    gboolean
    g_signal_accumulator_first_wins (GSignalInvocationHint *ihint,
                                     GValue *return_accu,
                                     const GValue *handler_return,
                                     gpointer dummy);

A predefined GSignalAccumulator for signals intended to be used as a hook for application code to provide a particular value. Usually only one such value is desired and multiple handlers for the same signal don't make much sense (except for the case of the default handler defined in the class structure, in which case you will usually want the signal connection to override the class handler).

This accumulator will use the return value from the first signal handler that is run as the return value for the signal and not run any further handlers (ie: the first handler "wins").

#### Parameters

ihint | standard GSignalAccumulator parameter |
return_accu | standard GSignalAccumulator parameter |
handler_return | standard GSignalAccumulator parameter |
dummy | standard GSignalAccumulator parameter |

#### Returns

standard GSignalAccumulator result

Since: 2.28

### g_signal_accumulator_true_handled ()

    gboolean
    g_signal_accumulator_true_handled (GSignalInvocationHint *ihint,
                                       GValue *return_accu,
                                       const GValue *handler_return,
                                       gpointer dummy);

A predefined GSignalAccumulator for signals that return a boolean values. The behavior that this accumulator gives is that a return of `TRUE` stops the signal emission: no further callbacks will be invoked, while a return of `FALSE` allows the emission to continue. The idea here is that a `TRUE` return indicates that the callback handled the signal, and no further handling is needed.

#### Parameters

ihint | standard GSignalAccumulator parameter |
return_accu | standard GSignalAccumulator parameter |
handler_return | standard GSignalAccumulator parameter |
dummy | standard GSignalAccumulator parameter |

#### Returns

standard GSignalAccumulator result

Since: 2.4

## Types and Values

### struct GSignalInvocationHint

    struct GSignalInvocationHint {
      guint		signal_id;
      GQuark detail;
      GSignalFlags run_type;
    };

The GSignalInvocationHint structure is used to pass on additional information to callbacks during a signal emission.

#### Members

guint `signal_id`; | The signal id of the signal invoking the callback |
GQuark `detail`; | The detail passed on for this emission |
GSignalFlags `run_type`; | The stage the signal emission is currently in, this field will contain one of `G_SIGNAL_RUN_FIRST`, `G_SIGNAL_RUN_LAST` or `G_SIGNAL_RUN_CLEANUP`. |

### GSignalCMarshaller

    typedef GClosureMarshal			 GSignalCMarshaller;

This is the signature of marshaller functions, required to marshall arrays of parameter values to signal emissions into C language callback invocations. It is merely an alias to GClosureMarshal since the GClosure mechanism takes over responsibility of actual function invocation for the signal system.

### GSignalCVaMarshaller

    typedef GVaClosureMarshal		 GSignalCVaMarshaller;

This is the signature of va_list marshaller functions, an optional marshaller that can be used in some situations to avoid marshalling the signal argument into GValues.

### enum GSignalFlags

The signal flags are used to specify a signal's behaviour, the overall signal description outlines how especially the RUN flags control the stages of a signal emission.

#### Members

G_SIGNAL_RUN_FIRST | Invoke the object method handler in the first emission stage. |
G_SIGNAL_RUN_LAST | Invoke the object method handler in the third emission stage. |
G_SIGNAL_RUN_CLEANUP | Invoke the object method handler in the last emission stage. |
G_SIGNAL_NO_RECURSE | Signals being emitted for an object while currently being in emission for this very object will not be emitted recursively, but instead cause the first emission to be restarted. |
G_SIGNAL_DETAILED | This signal supports "::detail" appendices to the signal name upon handler connections and emissions. |
G_SIGNAL_ACTION | Action signals are signals that may freely be emitted on alive objects from user code via `g_signal_emit()` and friends, without the need of being embedded into extra code that performs pre or post emission adjustments on the object. They can also be thought of as object methods which can be called generically by third-party code. |
G_SIGNAL_NO_HOOKS | No emissions hooks are supported for this signal. |
G_SIGNAL_MUST_COLLECT | Varargs signal emission will always collect the arguments, even if there are no signal handlers connected. Since 2.30. |
G_SIGNAL_DEPRECATED | The signal is deprecated and will be removed in a future version. A warning will be generated if it is connected while running with G_ENABLE_DIAGNOSTIC=1. Since 2.32. |

### enum GSignalMatchType

The match types specify what `g_signal_handlers_block_matched()`, `g_signal_handlers_unblock_matched()` and `g_signal_handlers_disconnect_matched()` match signals by.

#### Members

G_SIGNAL_MATCH_ID | The signal id must be equal. |
G_SIGNAL_MATCH_DETAIL | The signal detail be equal. |
G_SIGNAL_MATCH_CLOSURE | The closure must be the same. |
G_SIGNAL_MATCH_FUNC | The C closure callback must be the same. |
G_SIGNAL_MATCH_DATA | The closure data must be the same. |
G_SIGNAL_MATCH_UNBLOCKED | Only unblocked signals may matched. |

### struct GSignalQuery

    struct GSignalQuery {
      guint		signal_id;
      const gchar  *signal_name;
      GType		itype;
      GSignalFlags signal_flags;
      GType		return_type; /* mangled with G_SIGNAL_TYPE_STATIC_SCOPE flag */
      guint		n_params;
      const GType  *param_types; /* mangled with G_SIGNAL_TYPE_STATIC_SCOPE flag */
    };

A structure holding in-depth information for a specific signal. It is filled in by the `g_signal_query()` function.

#### Members

guint `signal_id`; | The signal id of the signal being queried, or 0 if the signal to be queried was unknown. |
const gchar *`signal_name`; | The signal name. |
GType `itype`; | The interface/instance type that this signal can be emitted for. |
GSignalFlags `signal_flags`; | The signal flags as passed in to `g_signal_new()`. |
GType `return_type`; | The return type for user callbacks. |
guint `n_params`; | The number of parameters that user callbacks take. |

const GType *`param_types`;

The individual parameter types for user callbacks, note that the effective callback signature is:

    1
    2
    3

    @return_type callback (#gpointer     data1,
    [param_types param_names,]
    gpointer     data2);

.

[array length=n_params]

### G_SIGNAL_TYPE_STATIC_SCOPE

    #define G_SIGNAL_TYPE_STATIC_SCOPE (G_TYPE_FLAG_RESERVED_ID_BIT)

This macro flags signal argument types for which the signal system may assume that instances thereof remain persistent across all signal emissions they are used in. This is only useful for non ref-counted, value-copy types.

To flag a signal argument in this way, add `| G_SIGNAL_TYPE_STATIC_SCOPE` to the corresponding argument of `g_signal_new()`.

    1
    2
    3
    4
    5
    6
    7
    8

    g_signal_new ("size_request",
      G_TYPE_FROM_CLASS (gobject_class),
    	 G_SIGNAL_RUN_FIRST,
    	 G_STRUCT_OFFSET (GtkWidgetClass, size_request),
    	 NULL, NULL,
    	 _gtk_marshal_VOID__BOXED,
    	 G_TYPE_NONE, 1,
    	 GTK_TYPE_REQUISITION | G_SIGNAL_TYPE_STATIC_SCOPE);

### G_SIGNAL_MATCH_MASK

    #define G_SIGNAL_MATCH_MASK  0x3f

A mask for all GSignalMatchType bits.

### G_SIGNAL_FLAGS_MASK

    #define G_SIGNAL_FLAGS_MASK  0x1ff

A mask for all GSignalFlags bits.

### enum GConnectFlags

The connection flags are used to specify the behaviour of a signal's connection.

#### Members

G_CONNECT_AFTER | whether the handler should be called before or after the default handler of the signal. |
G_CONNECT_SWAPPED | whether the instance and data should be swapped when calling the handler; see `g_signal_connect_swapped()` for an example. |